com.fasterxml.jackson.core.base

## Class GeneratorBase

- java.lang.Object
- - com.fasterxml.jackson.core.JsonGenerator
  - - com.fasterxml.jackson.core.base.GeneratorBase

All Implemented Interfaces:
  Versioned, Closeable, Flushable, AutoCloseable

Direct Known Subclasses:
  JsonGeneratorImpl

    public abstract class GeneratorBase
    extends JsonGenerator

This base class implements part of API that a JSON generator exposes to applications, adds shared internal methods that sub-classes can use and adds some abstract methods sub-classes must implement.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonGenerator

`JsonGenerator.Feature`

### Field Summary

Fields
`protected boolean` `_cfgNumbersAsStrings` Flag set to indicate that implicit conversion from number to JSON String is needed (as per `JsonGenerator.Feature.WRITE_NUMBERS_AS_STRINGS`).
`protected boolean` `_closed` Flag that indicates whether generator is closed or not.
`protected int` `_features` Bit flag composed of bits that indicate which `JsonGenerator.Feature`s are enabled.
`protected ObjectCodec` `_objectCodec`
`protected JsonWriteContext` `_writeContext` Object that keeps track of the current contextual state of the generator.

### Fields inherited from class com.fasterxml.jackson.core.JsonGenerator

`_cfgPrettyPrinter`

### Constructor Summary

Constructors
`protected` `GeneratorBase(int features, ObjectCodec codec)`

### Method Summary

Methods
`protected abstract void` `_releaseBuffers()` Method called to release any buffers generator may be holding, once generator is being closed.
`protected void` `_reportError(String msg)` Helper method used for constructing and throwing `JsonGenerationException` with given base message.
`protected void` `_reportUnsupportedOperation()`
`protected void` `_throwInternal()`
`protected abstract void` `_verifyValueWrite(String typeMsg)` Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.
`protected void` `_writeSimpleObject(Object value)` Helper method to try to call appropriate write method for given untyped Object.
`void` `close()` Method called to close this generator, so that no more content can be written.
`void` `copyCurrentEvent(JsonParser jp)` Method for copying contents of the current event that the given parser instance points to.
`void` `copyCurrentStructure(JsonParser jp)` Method for copying contents of the current event and following events that it encloses the given parser instance points to.
`JsonGenerator` `disable(JsonGenerator.Feature f)` Method for disabling specified features (check `JsonGenerator.Feature` for list of features)
`JsonGenerator` `enable(JsonGenerator.Feature f)` Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.
`abstract void` `flush()` Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.
`ObjectCodec` `getCodec()` Method for accessing the object used for writing Java object as Json content (using method `JsonGenerator.writeObject(java.lang.Object)`).
`JsonWriteContext` `getOutputContext()` Note: co-variant return type.
`boolean` `isClosed()` Method that can be called to determine whether this generator is closed or not.
`boolean` `isEnabled(JsonGenerator.Feature f)` Method for checking whether given feature is enabled.
`JsonGenerator` `setCodec(ObjectCodec oc)` Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).
`JsonGenerator` `useDefaultPrettyPrinter()` Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).
`Version` `version()` Implemented with detection that tries to find "VERSION.txt" in same package as the implementation class.
`int` `writeBinary(Base64Variant b64variant, InputStream data, int dataLength)` Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.
`void` `writeFieldName(SerializableString name)` Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.
`void` `writeObject(Object value)` Method for writing given Java object (POJO) as Json.
`void` `writeRawValue(char[] text, int offset, int len)`
`void` `writeRawValue(String text)` Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List).
`void` `writeRawValue(String text, int offset, int len)`
`void` `writeString(SerializableString text)` Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.
`void` `writeTree(TreeNode rootNode)` Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator.

### Methods inherited from class com.fasterxml.jackson.core.JsonGenerator

`canUseSchema, configure, getCharacterEscapes, getHighestEscapedChar, getOutputTarget, getPrettyPrinter, getSchema, setCharacterEscapes, setHighestNonEscapedChar, setPrettyPrinter, setRootValueSeparator, setSchema, writeArrayFieldStart, writeBinary, writeBinary, writeBinary, writeBinary, writeBinaryField, writeBoolean, writeBooleanField, writeEndArray, writeEndObject, writeFieldName, writeNull, writeNullField, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumber, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeNumberField, writeObjectField, writeObjectFieldStart, writeRaw, writeRaw, writeRaw, writeRaw, writeRaw, writeRawUTF8String, writeStartArray, writeStartObject, writeString, writeString, writeStringField, writeUTF8String`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _objectCodec

    protected ObjectCodec _objectCodec

#### _features

    protected int _features

Bit flag composed of bits that indicate which `JsonGenerator.Feature`s are enabled.

#### _cfgNumbersAsStrings

    protected boolean _cfgNumbersAsStrings

Flag set to indicate that implicit conversion from number to JSON String is needed (as per `JsonGenerator.Feature.WRITE_NUMBERS_AS_STRINGS`).

#### _writeContext

    protected JsonWriteContext _writeContext

Object that keeps track of the current contextual state of the generator.

#### _closed

    protected boolean _closed

Flag that indicates whether generator is closed or not. Gets set when it is closed by an explicit call (`close()`).

### Constructor Detail

#### GeneratorBase

    protected GeneratorBase(int features,
                 ObjectCodec codec)

### Method Detail

#### version

    public Version version()

Implemented with detection that tries to find "VERSION.txt" in same package as the implementation class.

Specified by:
  `version` in interface `Versioned`
Specified by:
  `version` in class `JsonGenerator`

#### enable

    public JsonGenerator enable(JsonGenerator.Feature f)

Description copied from class: `JsonGenerator`
Method for enabling specified parser features: check `JsonGenerator.Feature` for list of available features.

Specified by:
  `enable` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### disable

    public JsonGenerator disable(JsonGenerator.Feature f)

Description copied from class: `JsonGenerator`
Method for disabling specified features (check `JsonGenerator.Feature` for list of features)

Specified by:
  `disable` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### isEnabled

    public final boolean isEnabled(JsonGenerator.Feature f)

Description copied from class: `JsonGenerator`
Method for checking whether given feature is enabled. Check `JsonGenerator.Feature` for list of available features.

Specified by:
  `isEnabled` in class `JsonGenerator`

#### useDefaultPrettyPrinter

    public JsonGenerator useDefaultPrettyPrinter()

Description copied from class: `JsonGenerator`
Convenience method for enabling pretty-printing using the default pretty printer (`DefaultPrettyPrinter`).

Specified by:
  `useDefaultPrettyPrinter` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### setCodec

    public JsonGenerator setCodec(ObjectCodec oc)

Description copied from class: `JsonGenerator`
Method that can be called to set or reset the object to use for writing Java objects as JsonContent (using method `JsonGenerator.writeObject(java.lang.Object)`).

Specified by:
  `setCodec` in class `JsonGenerator`
Returns:
  Generator itself (this), to allow chaining

#### getCodec

    public final ObjectCodec getCodec()

Description copied from class: `JsonGenerator`
Method for accessing the object used for writing Java object as Json content (using method `JsonGenerator.writeObject(java.lang.Object)`).

Specified by:
  `getCodec` in class `JsonGenerator`

#### getOutputContext

    public final JsonWriteContext getOutputContext()

Note: co-variant return type.

Specified by:
  `getOutputContext` in class `JsonGenerator`
Returns:
  Context object that can give information about logical position within generated json content.

#### writeFieldName

    public void writeFieldName(SerializableString name)
                        throws IOException,
                               JsonGenerationException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeFieldName(String)`, main difference being that it may perform better as some of processing (such as quoting of certain characters, or encoding into external encoding if supported by generator) can be done just once and reused for later calls.

Default implementation simple uses unprocessed name container in serialized String; implementations are strongly encouraged to make use of more efficient methods argument object has.

Specified by:
  `writeFieldName` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonGenerationException`

#### writeString

    public void writeString(SerializableString text)
                     throws IOException,
                            JsonGenerationException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeString(String)`, but that takes `SerializableString` which can make this potentially more efficient to call as generator may be able to reuse quoted and/or encoded representation.

Default implementation just calls `JsonGenerator.writeString(String)`; sub-classes should override it with more efficient implementation if possible.

Specified by:
  `writeString` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonGenerationException`

#### writeRawValue

    public void writeRawValue(String text)
                       throws IOException,
                              JsonGenerationException

Description copied from class: `JsonGenerator`
Method that will force generator to copy input text verbatim without any modifications, but assuming it must constitute a single legal JSON value (number, string, boolean, null, Array or List). Assuming this, proper separators are added if and as needed (comma or colon), and generator state updated to reflect this.

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonGenerationException`

#### writeRawValue

    public void writeRawValue(String text,
                     int offset,
                     int len)
                       throws IOException,
                              JsonGenerationException

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonGenerationException`

#### writeRawValue

    public void writeRawValue(char[] text,
                     int offset,
                     int len)
                       throws IOException,
                              JsonGenerationException

Specified by:
  `writeRawValue` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonGenerationException`

#### writeBinary

    public int writeBinary(Base64Variant b64variant,
                  InputStream data,
                  int dataLength)
                    throws IOException,
                           JsonGenerationException

Description copied from class: `JsonGenerator`
Method similar to `JsonGenerator.writeBinary(Base64Variant,byte[],int,int)`, but where input is provided through a stream, allowing for incremental writes without holding the whole input in memory.

Specified by:
  `writeBinary` in class `JsonGenerator`
Parameters:
  `b64variant` - Base64 variant to use
  `data` - InputStream to use for reading binary data to write. Will not be closed after successful write operation
  `dataLength` - (optional) number of bytes that will be available; or -1 to be indicate it is not known. If a positive length is given, `data` MUST provide at least that many bytes: if not, an exception will be thrown. Note that implementations need not support cases where length is not known in advance; this depends on underlying data format: JSON output does NOT require length, other formats may.
Returns:
  Number of bytes read from `data` and written as binary payload
Throws:
  `IOException`
  `JsonGenerationException`

#### writeObject

    public void writeObject(Object value)
                     throws IOException,
                            JsonProcessingException

Description copied from class: `JsonGenerator`
Method for writing given Java object (POJO) as Json. Exactly how the object gets written depends on object in question (ad on codec, its configuration); for most beans it will result in Json object, but for others Json array, or String or numeric value (and for nulls, Json null literal. NOTE: generator must have its object codec set to non-null value; for generators created by a mapping factory this is the case, for others not.

Specified by:
  `writeObject` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonProcessingException`

#### writeTree

    public void writeTree(TreeNode rootNode)
                   throws IOException,
                          JsonProcessingException

Description copied from class: `JsonGenerator`
Method for writing given JSON tree (expressed as a tree where given JsonNode is the root) using this generator. This will generally just call `JsonGenerator.writeObject(java.lang.Object)` with given node, but is added for convenience and to make code more explicit in cases where it deals specifically with trees.

Specified by:
  `writeTree` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonProcessingException`

#### flush

    public abstract void flush()
                        throws IOException

Description copied from class: `JsonGenerator`
Method called to flush any buffered content to the underlying target (output stream, writer), and to flush the target itself as well.

Specified by:
  `flush` in interface `Flushable`
Specified by:
  `flush` in class `JsonGenerator`
Throws:
  `IOException`

#### close

    public void close()
               throws IOException

Description copied from class: `JsonGenerator`
Method called to close this generator, so that no more content can be written.

Whether the underlying target (stream, writer) gets closed depends on whether this generator either manages the target (i.e. is the only one with access to the target -- case if caller passes a reference to the resource such as File, but not stream); or has feature `JsonGenerator.Feature.AUTO_CLOSE_TARGET` enabled. If either of above is true, the target is also closed. Otherwise (not managing, feature not enabled), target is not closed.

Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in class `JsonGenerator`
Throws:
  `IOException`

#### isClosed

    public boolean isClosed()

Description copied from class: `JsonGenerator`
Method that can be called to determine whether this generator is closed or not. If it is closed, no more output can be done.

Specified by:
  `isClosed` in class `JsonGenerator`

#### copyCurrentEvent

    public final void copyCurrentEvent(JsonParser jp)
                                throws IOException,
                                       JsonProcessingException

Description copied from class: `JsonGenerator`
Method for copying contents of the current event that the given parser instance points to. Note that the method will not copy any other events, such as events contained within Json Array or Object structures.

Calling this method will not advance the given parser, although it may cause parser to internally process more data (if it lazy loads contents of value events, for example)

Specified by:
  `copyCurrentEvent` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonProcessingException`

#### copyCurrentStructure

    public final void copyCurrentStructure(JsonParser jp)
                                    throws IOException,
                                           JsonProcessingException

Description copied from class: `JsonGenerator`
Method for copying contents of the current event and following events that it encloses the given parser instance points to.

So what constitutes enclosing? Here is the list of events that have associated enclosed events that will get copied:

- `JsonToken.START_OBJECT`: all events up to and including matching (closing) `JsonToken.END_OBJECT` will be copied
- `JsonToken.START_ARRAY` all events up to and including matching (closing) `JsonToken.END_ARRAY` will be copied
- `JsonToken.FIELD_NAME` the logical value (which can consist of a single scalar value; or a sequence of related events for structured types (Json Arrays, Objects)) will be copied along with the name itself. So essentially the whole field entry (name and value) will be copied.

After calling this method, parser will point to the last event that was copied. This will either be the event parser already pointed to (if there were no enclosed events), or the last enclosed event copied.

Specified by:
  `copyCurrentStructure` in class `JsonGenerator`
Throws:
  `IOException`
  `JsonProcessingException`

#### _releaseBuffers

    protected abstract void _releaseBuffers()

Method called to release any buffers generator may be holding, once generator is being closed.

#### _verifyValueWrite

    protected abstract void _verifyValueWrite(String typeMsg)
                                       throws IOException,
                                              JsonGenerationException

Method called before trying to write a value (scalar or structured), to verify that this is legal in current output state, as well as to output separators if and as necessary.

Parameters:
  `typeMsg` - Additional message used for generating exception message if value output is NOT legal in current generator output state.
Throws:
  `IOException`
  `JsonGenerationException`

#### _reportError

    protected void _reportError(String msg)
                         throws JsonGenerationException

Helper method used for constructing and throwing `JsonGenerationException` with given base message.

Note that sub-classes may override this method to add more detail or use a `JsonGenerationException` sub-class.

Throws:
  `JsonGenerationException`

#### _writeSimpleObject

    protected void _writeSimpleObject(Object value)
                               throws IOException,
                                      JsonGenerationException

Helper method to try to call appropriate write method for given untyped Object. At this point, no structural conversions should be done, only simple basic types are to be coerced as necessary.

Parameters:
  `value` - Non-null value to write
Throws:
  `IOException`
  `JsonGenerationException`

#### _throwInternal

    protected final void _throwInternal()

#### _reportUnsupportedOperation

    protected void _reportUnsupportedOperation()